#include <algorithm>
#include <cmath>
#include <ext/alloc_traits.h>
#include <iostream>
#include <memory>
#include <vector>

using namespace std;

typedef vector<int> vi;
typedef vector<vi> vvi;

vi r;

bool is_valid(int i0) {
  double lbn = 9.0 / 10.0 * i0 / r[0];
  double ubn = 10.0 / 9.0 * i0 / r[0];

  if (ceil(lbn - 1e-9) > floor(ubn + 1e-9))
    return false;

  return true;
}

bool is_valid(int i0, int i1) {
  double lbn = 9.0 / 10.0 * i0 / r[0];
  double ubn = 10.0 / 9.0 * i0 / r[0];

  for (int n = ceil(lbn - 1e-9); n < (ubn + 1e-9); n++) {
    // check if ingredient 2 is within tolerance
    if (i1 > (9.0 / 10.0 * n * r[1] - 1e-9) &&
        i1 < (10.0 / 9.0 * n * r[1] + 1e-9)) {
      return true;
    }
  }

  return false;
}

int main() {

  int t;
  cin >> t;
  int cas = 1;
  while (t--) {
    cout << "Case #" << cas << ": ";
    cas++;

    int n, p;
    cin >> n >> p;
    r = vi();
    for (int i = 0; i < n; i++) {
      int temp;
      cin >> temp;
      r.push_back(temp);
    }

    vvi q;
    for (int i = 0; i < n; i++) {
      q.push_back(vi());
      for (int j = 0; j < p; j++) {
        int temp;
        cin >> temp;
        q[i].push_back(temp);
      }
    }

    if (n == 1) {
      int count = 0;
      for (int i = 0; i < p; i++) {
        if (is_valid(q[0][i])) {
          count++;
        }
      }
      cout << count << endl;
    } else if (n == 2) {
      vi ordering = q[1];
      sort(ordering.begin(), ordering.end());
      int max_count = -1;
      int count = 0;
      do {
        count = 0;
        for (int i = 0; i < p; i++) {
          if (is_valid(q[0][i], ordering[i])) {
            count++;
          }
        }

        if (count > max_count) {
          max_count = count;
        }
      } while (next_permutation(ordering.begin(), ordering.end()));

      cout << count << endl;
    }
  }

  return 0;
}
