#include <algorithm>
#include <functional>
#include <memory>
#include <stdio.h>
#include <utility>
#include <vector>

typedef std::pair<long long int, long long int> lp;

void process(int TEST_CASE) {
  long long int dest;
  int n;
  std::vector<lp> horse;

  scanf("%lld%d", &dest, &n);
  for (int i = 0; i < n; i++) {
    long long int pos, vel;
    scanf("%lld%lld", &pos, &vel);
    horse.push_back(std::make_pair(pos, vel));
  }
  std::sort(horse.begin(), horse.end(), std::greater<lp>());

  double ans = 0.0;
  for (int i = 0; i < horse.size(); i++) {
    double est = (double)(dest - horse[i].first) / (horse[i].second);
    ans = std::max(ans, est);
  }

  printf("Case #%d: %.6lf\n", TEST_CASE, dest / ans);
}

int main() {

  int t;
  scanf("%d", &t);
  for (int i = 1; i <= t; i++) {
    process(i);
  }
}
