#include <algorithm>
#include <ext/alloc_traits.h>
#include <iostream>
#include <iterator>
#include <math.h>
#include <stdio.h>
#include <vector>

using namespace std;

template <class T> bool chmax(T &a, const T &b) {
  if (a < b) {
    a = b;
    return true;
  }
  return false;
}

using Weight = long long;
using Flow = long long;
struct Edge {
  long long s, d;
  Weight w;
  Flow c;
  Edge(){};
  Edge(long long s, long long d, Weight w = 1) : s(s), d(d), w(w), c(w){};
};
bool operator<(const Edge &e1, const Edge &e2) { return e1.w < e2.w; }
bool operator>(const Edge &e1, const Edge &e2) { return e2 < e1; }
inline ostream &operator<<(ostream &os, const Edge &e) {
  return (os << '(' << e.s << ", " << e.d << ", " << e.w << ')');
}

signed main() {
  cin.tie(0);
  ios::sync_with_stdio(false);
  freopen("B-small-attempt0.in", "r", stdin);
  freopen("B-small-attempt0.txt", "w", stdout);
  // freopen("in.txt", "r", stdin);
  ////freopen("out.txt", "w", stdout);
  long long T;
  cin >> T;
  for (long long t = 0; t < T; t++) {
    long long N, P;
    cin >> N >> P;
    vector<long long> R(N);
    for (long long i = (0); i < (N); i++) {
      cin >> R[i];
    }
    vector<vector<long long>> Q(N, vector<long long>(P));
    for (long long i = (0); i < (N); i++)
      for (long long j = (0); j < (P); j++) {
        cin >> Q[i][j];
      }

    if (N == 1) {
      long long ans = 0;
      for (long long i = (0); i < (P); i++) {
        long long a = ceil(Q[0][i] * 100 / 110.0 / R[0]);
        long long b = Q[0][i] * 100 / 90.0 / R[0];
        if (a <= b)
          ans++;
      }
      cout << "Case #" << t + 1 << ": " << ans << endl;
      continue;
    }

    sort(begin(Q[0]), end(Q[0]));
    sort(begin(Q[1]), end(Q[1]));
    ;
    long long ans = 0;
    do {
      long long cnt = 0;
      for (long long i = (0); i < (P); i++) {
        long long a = ceil(Q[0][i] * 100 / 110.0 / R[0]);
        long long b = Q[0][i] * 100 / 90.0 / R[0];
        long long c = ceil(Q[1][i] * 100 / 110.0 / R[1]);
        long long d = Q[1][i] * 100 / 90.0 / R[1];
        // dump(a, b, c, d);
        if (a <= d && c <= b)
          cnt++;
      }
      chmax(ans, cnt);
    } while (next_permutation(begin(Q[1]), end(Q[1])));

    cout << "Case #" << t + 1 << ": " << ans << endl;
  }
  return 0;
}
