#include <functional>
#include <iostream>
#include <iterator>
#include <map>
#include <utility>
#include <vector>

using namespace std;

typedef long long ll;

template <typename T1, typename T2>
ostream &operator<<(ostream &os, const pair<T1, T2> &p) {
  return os << '(' << p.first << ',' << p.second << ')';
}

template <typename T> ostream &operator<<(ostream &os, const vector<T> &a) {
  os << '[';
  for (int i = 0; i < (int)(a.size()); i++)
    os << (i ? " " : "") << a[i];
  return os << ']';
}

// a^k

void solve() {
  ll N, K;
  cin >> N >> K;

  map<ll, ll, greater<ll>> nums;
  nums[N] = 1;

  while (true) {
    ll now = begin(nums)->first;
    if (now == 0)
      break;
    ll count = begin(nums)->second;

    ll left = now / 2;
    ll right = (now - 1) / 2;

    K -= count;
    if (K <= 0) {
      cout << left << " " << right;
      return;
    }

    nums[left] += count;
    nums[right] += count;

    nums.erase(now);
  }

  cout << "0 0";
}

int main() {
  int T;
  cin >> T;
  for (int _t = 0; _t < (int)(T); _t++) {
    cout << "Case #" << (_t + 1) << ": ";
    solve();
    cout << endl;
  }
  return 0;
}
