#include <iostream>
#include <string>
#include <utility>
#include <vector>

using namespace std;

template <typename T1, typename T2>
ostream &operator<<(ostream &os, const pair<T1, T2> &p) {
  return os << '(' << p.first << ',' << p.second << ')';
}

template <typename T> ostream &operator<<(ostream &os, const vector<T> &a) {
  os << '[';
  for (int i = 0; i < (int)(a.size()); i++)
    os << (i ? " " : "") << a[i];
  return os << ']';
}

// a^k

void solve() {
  string pans;
  int K;
  cin >> pans >> K;

  int ans = 0;
  for (int i = 0; i < (int)(pans.size() - K + 1); i++) {
    if (pans[i] == '-') {
      ans++;
      for (int j = 0; j < (int)(K); j++) {
        pans[i + j] = (pans[i + j] == '+') ? '-' : '+';
      }
    }
  }

  for (int i = 0; i < (int)(pans.size()); i++) {
    if (pans[i] == '-') {
      cout << "IMPOSSIBLE";
      return;
    }
  }

  cout << ans;
}

int main() {
  int T;
  cin >> T;
  for (int _t = 0; _t < (int)(T); _t++) {
    cout << "Case #" << (_t + 1) << ": ";
    solve();
    cout << endl;
  }
  return 0;
}
