#include <ext/alloc_traits.h>
// C++
#include <algorithm>
#include <cmath>
#include <iostream>
#include <memory>
#include <utility>
#include <vector>

using namespace std;

typedef vector<int> vi;

typedef vector<vi> vvi;

typedef pair<int, int> pii;

template <typename T1, typename T2>
ostream &operator<<(ostream &os, const pair<T1, T2> &p) {
  return os << '(' << p.first << ',' << p.second << ')';
}

template <typename T> ostream &operator<<(ostream &os, const vector<T> &a) {
  os << '[';
  for (int i = 0; i < (int)(a.size()); i++)
    os << (i ? " " : "") << a[i];
  return os << ']';
}

// a^k

pii conv(int now) {
  int e = floor((double)now / 0.9);
  int s = ceil((double)now / 1.1);
  return make_pair(s, e);
}

void solve() {
  int N, P;
  cin >> N >> P;

  vi R(N);
  for (int i = 0; i < (int)(N); i++)
    cin >> R[i];

  vvi Q(N, vi(P));
  for (int i = 0; i < (int)(N); i++) {
    for (int j = 0; j < (int)(P); j++) {
      cin >> Q[i][j];
    }
  }

  for (int i = 0; i < (int)(N); i++) {
    sort(((Q[i]).begin()), ((Q[i]).end()));
  }

  vector<vector<pii>> need(N, vector<pii>(P));
  for (int i = 0; i < (int)(N); i++) {
    for (int j = 0; j < (int)(P); j++) {
      need[i][j] = conv(Q[i][j]);
    }
  }

  int ans = 0;
  if (N <= 2) {
    for (int pack = 0; pack < (int)(P); pack++) {
      int from = ceil((double)need[0][pack].first / R[0]);
      int to = floor((double)need[0][pack].second / R[0]);

      bool gok = false;
      for (int i = from; i < (int)(to + 1); i++) {
        bool ok = (need[0][pack].first <= R[0] * i &&
                   R[0] * i <= need[0][pack].second);
        //                cout << " fc: " << need[0][pack].first << " " <<
        //                R[0]*i << " & "<<  R[0]*i << " " <<
        //                need[0][pack].second << endl;

        if (!ok)
          continue;

        ok = (N == 1);

        for (int g = 1; g < (int)(N); g++) {
          for (int p = 0; p < (int)(P); p++) {
            if (need[g][p].first <= R[g] * i && R[g] * i <= need[g][p].second) {
              //                            cout << need[g][p].first << " " <<
              //                            R[g]*i << " & "<<  R[g]*i << " " <<
              //                            need[g][p].second << endl;
              ok = true;
              need[g][p] = make_pair(-1, -1);
              break;
            }
          }
        }

        gok |= ok;

        if (ok)
          break;
      }

      if (gok) {
        ans++;
      }
    }

    cout << ans;
  } else {
    cout << "IMP";
  }
}

int main() {
  int T;
  cin >> T;
  for (int _t = 0; _t < (int)(T); _t++) {
    cout << "Case #" << (_t + 1) << ": ";
    solve();
    cout << endl;
  }
  return 0;
}
